//addpinou.js
//voeg pinout toe
//19970601/wjvg omgezet naar uhl+js

var np=parseInt(location.search.substring(1));

if (np==0) np=16;

function wrln(ps) {document.writeln(ps);}

wrln("<h2>Add the pinout of a chip with "+np+" pins.</h2>");

function clear_pins()
{
  for (var i=0;i<np;++i) {
    document.form0["pin"+i].value="";
  }
  return 0;
}

function on_submit()
{
  document.form0.subject.value=document.form0.chip_name.value+".txt";  //init de string
  if (document.form0.from.value!="") {
    document.form0.to.value+=","+
    document.form0.from.value;
  }
  if (!f_format) {
    document.form0.body.value=format();
    f_format=true;
  }
}

function list_changed()
{
  var name=document.form0.list.selectedIndex;

  document.form0.chip_name    .value=document.form0.list.options[name].chip_name;
  document.form0.chip_function.value=document.form0.list.options[name].chip_function;
  document.form0.manufacturer .value=document.form0.list.options[name].manufacturer;
  document.form0.comment      .value=document.form0.list.options[name].comment;
  document.form0.body         .value=document.form0.list.options[name].body;
  for (var i=0;i<np;++i) {
    document.form0["pin"+i].value=document.form0.list.options[name]["pin"+i];
  }
}

function list_all_chips()
{
//var name=document.form0.list.selectedIndex;
  var sep=",";
  var st ="";

  for (i=0;i<document.form0.list.length;++i) {
    st+=document.form0.list.options[i].chip_name    +sep;
    st+=document.form0.list.options[i].chip_function+sep;
    st+=document.form0.list.options[i].manufacturer +sep;
    st+=document.form0.list.options[i].comment      +sep;
    st+=np+sep;
    for (var p=0;p<np;++p) {
      st+=document.form0.list.options[i]["pin"+p]+sep;
    }
    st+="\n";
  }
  return st;
}

function save_chip()
{
  var name=document.form0.list.options.length;

  document.form0.list.options[name]=new Option(name,name,0,1);
  document.form0.list.options[name].text         =document.form0.chip_name.value;
  document.form0.list.options[name].chip_name    =document.form0.chip_name.value;
  document.form0.list.options[name].chip_function=document.form0.chip_function.value;
  document.form0.list.options[name].manufacturer =document.form0.manufacturer.value;
  document.form0.list.options[name].comment      =document.form0.comment.value;
  document.form0.list.options[name].body         =document.form0.body.value;
  for (var i=0;i<np;++i) {
    document.form0.list.options[name]["pin"+i]=document.form0["pin"+i].value;
  }
}

function show_chip()
{
  nw=window.open("","newwin","menubar,scrollbars,resizable,width=300,height=200");
//nw.document.open("text/plain");
  nw.document.open();
//nw.document.location.url="test.txt";
//nw.document.title="Dit is de titel";
  nw.document.writeln("<html>");
  nw.document.writeln("  <head>");
  nw.document.writeln("    <title>"+document.form0.chip_name.value+"</title>");
  nw.document.writeln("  </head>");
  nw.document.writeln("  <body>");
  nw.document.writeln("    <pre>\n");
  nw.document.write(format());
  nw.document.writeln("    </pre>");
  nw.document.writeln("  </body>");
  nw.document.writeln("</html>");
  nw.document.close();
  nw.focus();
  return 0;
}

function format()
{
  var i;
  var mx=0;
  var n0="";
  var n1="";
  var s0="";
  var s1="";
  var sp;
  var ti="";
  var st="";            //init the string

  st="";                //init the string
  for (i=0;i<np;++i) {
    mx=Math.max(mx,document.form0["pin"+i].value.length);
  }
  for (sp="",i=0;i<mx;++i) sp+=" ";
  ti=document.form0.chip_name.value;
  for (i=(12-ti.length)/2;i>0;--i) {
    st+=" ";
  }
  st+=sp+ti+"\n";
  st+=sp+" +---()---+\n";
  for (i=0;i<np/2;++i) {
    s0=document.form0["pin"+(     i)].value;
    s1=document.form0["pin"+(np-1-i)].value;
    while (s0.length<mx) s0=" "+s0;
    n0=""+( 1+i); while (n0.length<2) n0=" "+n0;
    n1=""+(np-i); while (n1.length<2) n1=" "+n1;
    st+=s0+" |"+n0+"    "+n1+"| "+s1+"\n";
  }
  st+=sp+" +--------+\n";
  st+="function:     "+document.form0.chip_function.value+"\n";
  st+="package:      "+document.form0.housing      .value+"\n";
  st+="manufacturer: "+document.form0.manufacturer .value+"\n";
  if (document.form0.comment.value!="") {
    st+="comment:      "+document.form0.comment    .value+"\n";
  }
  return st;
}

wrln('<form name=form0 method=post action="http://www.xs4all.nl/cgi-bin/mail-a-form" onSubmit="on_submit();">');
wrln('<input type=hidden name=nextpage value="afterpin.htm">');
wrln('<input type=hidden name=to       value="ganswijk@xs4all.nl">');
wrln('<input type=hidden name=subject  value="--Added pinout--">');
wrln("<table border=1 cellspacing=5>");                //beide kolommen
wrln("<tr><td>");
wrln("<table border=1 cellspacing=0 cellpadding=0>");  //linker kolom
wrln("<tr><td>");
wrln("<table cellspacing=0 cellpadding=0>");           //velden bovenin
wrln("<tr><td>Chip name:   </td><td><input size=25 name=chip_name    ></td></tr>");
wrln("<tr><td>Function:    </td><td><input size=25 name=chip_function></td></tr>");
wrln("<tr><td>Manufacturer:</td><td><input size=25 name=manufacturer ></td></tr>");
wrln("<tr><td>Package:     </td><td><input size=25 name=housing      ></td></tr>");
wrln("<tr><td>Comment:     </td><td><input size=25 name=comment      ></td></tr>");
wrln("</table>");
wrln("</td></tr>");
wrln("<tr><td>");
wrln("<table cellspacing=0 cellpadding=0>");           //chip
wrln("<tr><td>");
wrln("<table cellspacing=0 cellpadding=0>");           //eerste kolom van chip
for (i=0;i<np/2;++i) {
  wrln("<tr>");
  wrln("  <td><input size=10 name=pin"+i+"></td>");
  wrln("  <td align=right>"+(i+1)+"</td>");
  wrln("</tr>");
}
wrln("</table></td>");
wrln("<td><pre>");
wrln(" +--()--+");
for (i=0;i<np/2;++i) {
  wrln(" |      | ");
}
wrln(" +------+");
wrln("</pre></td>");
wrln("<td><table cellspacing=0 cellpadding=0>");
for (i=np;--i>=np/2;) {
  wrln("<tr>");
  wrln("  <td>"+(1+i)+"</td>");
  wrln("  <td><input size=10 name=pin"+i+"></td>");
  wrln("</tr>");
}
wrln("</table></td>");  //laatste kolom van chip
wrln("</tr>");
wrln("</table>");       //chip
wrln("</td></tr>");
wrln("</table>");       //linker kolom
wrln("</td><td align=center>");
wrln('<input type=button value="Show pinout formatted:" onClick="document.form0.body.value=format();"><br>');
wrln("(Do this before sending)<br>");
wrln("(You can edit this field by hand before sending)<br>");
wrln("<br>");
wrln("<textarea name=body rows="+(7+np/2)+" cols=30></textarea><br>");
//wrln('<input type=button value="Show all pinouts short:" onClick="document.form0.table.value=list_all_chips();"><br>');
wrln("</td></tr></table>");
wrln("<hr>");
wrln('<input size=30 name=name> Your name (optional)<br>');
wrln('<input size=30 name=from> Your email address (to get a copy of the submitted form)<br>');
wrln('<hr>');
//wrln('<input type=button value="Show in window"  onClick="show_chip();"   > ');
//wrln('<input type=button value="Clear pins only" onClick="clear_pins();"  > ');
wrln('<input type=submit value="Send form"       onClick="send_form();"   > ');
wrln('<input type=reset  value="Clear form"      onClick="f_format=false;"> ');
//wrln('<input type=button value="Save in array"   onClick="save_chip();"   > ');
//wrln('<select name=list size=4                   onChange="list_changed();"> ');
//wrln('  <option>-none available yet-</option>');
//wrln('</select>');
//wrln('<hr>');
//wrln("<textarea name=table rows=6 cols=60></textarea><br>");
wrln("</form>");
wrln('<hr>');
wrln("The pinout will be added to the next version of the ChipDir!");
//wrln("It's not possible to add the pinouts to the ChipDir"
//     " automatically immediately unfortunately, but they WILL be added!<br>");

//end
