//am5394.h
//defines for the AM53c94 SCSI Controller
//19931020/wjvg, copied

//register map
#define TRX_LSB   0x00
#define TRX_MSB   0x01
#define FIFO      0x02
#define COMMAND   0x03
#define STATUS    0x04  //READ
#define DESTID    0x04  //WRITE
#define INTR      0x05  //READ
#define SELTO     0x05  //WRITE
#define SEQ_STEP  0x06  //READ
#define SYNCPER   0x06  //WRITE
#define FIFO_FLG  0x07  //READ
#define SYNC_OFF  0x07  //WRITE
#define CONFIG1   0x08
#define CLOCK_CV  0x09
#define TEST_MODE 0x0a
#define CONFIG2   0x0b
#define CONFIG3   0x0c
#define TRX_2     0x0d  //undocumented in NCR book!! ?? DKS
#define SRB       0x0f  //reserve fifo byte?? DKS

//commands
#define NOP          0x00
#define CLEAR_FIFO   0x01
#define RESET        0x02
#define RESET_SBUS   0x03
#define TARG_ABORT   0x04
#define TRX_INFO     0x10
#define ICMD_COMP    0x11
#define MSG_ACCP     0x12
#define TRX_PAD      0x18
#define SET_ATN      0x1a
#define RESET_ATN    0x1b
#define SEND_MSG     0x20
#define SEND_STAT    0x21
#define

//rest of file missing?
