<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html>
  <head>
     <title>Pin out database</title>
  </head>
  <body>
    <h1>Pinout database</h1>

<?php
    function print_array($p,$sz,$df) {
    print "<table border=1>\n";
    for ($i=0;$i<$sz && (list($key,$data)=each($p));++$i) {
      print "<tr><td>".($key+$df)."</td><td>".trim($data)."</td></tr>\n";
    }
    print "</table>\n";
  }

  function print_pinout($p,$np) {
    print "<table border=1>\n";
    for ($i=0;$i<$np/2;++$i) {
      print "<tr><td>$p[$i]</td><td>".(1+$i)."</td>\n";
      print "<td>".($np-$i)."</td><td>".$p[$np-$i-1]."</td></tr>\n";
    }
    print "</table>\n";
  }

  switch ($cmd) {
  case 'pinmatch':
    echo "You are looking for the pattern:<br>\n";
    print_pinout($pin,$npin);
    //for ($i=0;$i<$npin;++$i) echo "[".$pin[$i]."]";
    //echo "<br>\n";
  case 'search':
    $chrspc=chr(127);
    echo "<hr>\n";
    echo "results:<br>\n";
    if ($f_table) {
      echo "<table border=1><tr>\n";
      for ($i=0;$i<$npin;++$i) echo "<th>".(1+$i)."</th>";
      echo "<th>IC</th><th>description</th></tr>";
    }
    if ($hf=fopen("pinusr.pin","r")) {
      while (!feof($hf)) {
        $buf0=$buffer=fgets($hf,0x10000);
        if ($buffer[0]!=';') {
          for ($f_in_str=FALSE,$i=0;$i<strlen($buffer);++$i) {
            switch ($buffer[$i]) {
              case ',':
                if (!$f_in_str) $buffer[$i]=$chrspc;
                break;
              case '"':
                $f_in_str=!$f_in_str;
                $buffer[$i]=' ';
                break;
            }
          }
          //$Aic =explode($chrspc,$buffer,9);
          $Aic =explode($chrspc,$buffer);
          $np=$Aic[7];
          //$Apin=explode($chrspc,$Aic[8],$np+2);
          for ($i=0;$i<$np;++$i) $Apin[$i]=$Aic[8+$i];
          //print_array($Aic,25,0);
          //$nc=$Apin[$np];
          $nc=$Aic[8+$np];
          //$Acom=explode($chrspc,$Apin[$np+1],nc);
          for ($i=0;$i<$nc;++$i) $Acom[$i]=$Aic[8+$np+1+$i];
          $fl=FALSE;
          if ($cmd=='pinmatch' && $np==$npin) {
            for ($i=0;$i<$np && ($pin[$i]=='' || eregi($pin[$i],$Apin[$i]));++$i);
            if ($i==$np) $fl=TRUE;
          }
          if ($fl==TRUE || $cmd=='search' && eregi($data,$buffer)) {
            if ($f_table) {
              echo "<tr>";
              for ($i=0;$i<$np;++$i) {echo "<td>".$Apin[$i]."</td>";}
              echo "<td>".$Aic[0]."</td><td>".$Aic[1]."</td></tr>\n";
            }
            else {
              print "<hr>\n";
              //print $buf0."<br>\n";
              print_array($Aic,6,0);  //don't print email address
              print_pinout($Apin,$np);
              if ($nc) {
                print "comment:<br>\n";
                print_array($Acom,$nc,0);
              }
            }
          }
        }
        //if (++$t==10) break;
      }
    }
    else print "Can't open pin file.<br>\n";
    if ($f_table) echo "</table>\n";
    break;
  default:
    if ($npin==0) $npin=14;
    echo "<form method='post' action='$PHP_SELF'>\n";
    echo "  <input type=hidden   name='cmd'  value='search'>\n";
    echo "  <input type=text     name='data' value='P4C188'>\n";
    echo "  <input type=submit   name='do'   value='Search with (POSIX-style) regular expression'><br>\n";
    echo "</form>\n";
    echo "<hr>\n";
    echo "<form method='post' action='$PHP_SELF'>\n";
    echo "  <input type=hidden   name='cmd'  value='chnpin'>\n";
    echo "  <input type=text     name='npin'>\n";
    echo "  <input type=submit   name='do'   value='Change number of pins'><br>\n";
    echo "</form>\n";
    echo "<hr>\n";
    echo "<form method='post' action='$PHP_SELF'>\n";
    echo "  <input type=hidden   name='cmd'  value='pinmatch'>\n";
    echo "  <input type=hidden   name='npin' value='$npin'>\n";
    echo "<table border=1>\n";
    for ($i=0;$i<$npin/2;++$i) {
      echo "  <tr><td><input type=text name='pin[$i]' size=10></td><td>".(1+$i)."</td>";
      echo "  <td>".($npin-$i)."</td><td><input type=text name='pin[".($npin-$i-1)."]' size=10></td></tr>\n";
    }
    echo "</table>\n";
    echo "  <input type=checkbox name='f_table'>&nbsp;show results in single table?<br>\n";
    echo "  <input type=submit   name='do'      value='Match pins with (POSIX-style) regular expressions'><br>\n";
    echo "</form>\n";
    break;
  }

?>
  </body>
</html>

