//rs6000a.h
//the special purpose registers of the rs6000-family
//as index within an array
//19941024/wjvg

//nb. it is not completely clear which registers are present in the rs6000!

#define SPR_MQ        0  //U, 6000, 601
#define SPR_XER       1  //U, 6000, 601, 603
#define SPR_RTCU_R    4  //U, 6000, 601
#define SPR_RTCL_R    5  //U, 6000, 601
#define SPR_DEC_U     6  //U, 6000, 601
#define SPR_LR        8  //U, 6000, 601, 603
#define SPR_CTR       9  //U, 6000, 601, 603
#define SPR_DSISR    18  //S, 6000, 601, 603
#define SPR_DAR      19  //S, 6000, 601, 603
#define SPR_RTCU_W   20  //S, 6000, 601
#define SPR_RTCL_W   21  //S, 6000, 601
#define SPR_DEC      22  //S, 6000, 601, 603
#define SPR_SDR1     25  //S, 6000, 601, 603
#define SPR_SRR0     26  //S, 6000, 601, 603
#define SPR_SRR1     27  //S, 6000, 601, 603
#define SPR_SPRG0   272  //S, 6000, 601, 603
#define SPR_SPRG1   273  //S, 6000, 601, 603
#define SPR_SPRG2   274  //S, 6000, 601, 603
#define SPR_SPRG3   275  //S, 6000, 601, 603
#define SPR_ASR     280  //S, 6000,     (64-bit)
#define SPR_EAR     282  //S, 6000, 601, 603
#define SPR_TB      284  //S, 6000,    
#define SPR_TBU     285  //S, 6000,    
#define SPR_PVR     287  //S, 6000, 601, 603

#define SPR_IBAT0U  528  //S, 6000, 601, 603
#define SPR_IBAT0L  529  //S, 6000, 601, 603
#define SPR_IBAT1U  530  //S, 6000, 601, 603
#define SPR_IBAT1L  531  //S, 6000, 601, 603
#define SPR_IBAT2U  532  //S, 6000, 601, 603
#define SPR_IBAT2L  533  //S, 6000, 601, 603
#define SPR_IBAT3U  534  //S, 6000, 601, 603
#define SPR_IBAT3L  535  //S, 6000, 601, 603

#define SPR_DBAT0U  536  //S, 6000,      603
#define SPR_DBAT0L  537  //S, 6000,      603
#define SPR_DBAT1U  538  //S, 6000,      603
#define SPR_DBAT1L  539  //S, 6000,      603
#define SPR_DBAT2U  540  //S, 6000,      603
#define SPR_DBAT2L  541  //S, 6000,      603
#define SPR_DBAT3U  542  //S, 6000,      603
#define SPR_DBAT3L  543  //S, 6000,      603

#define SPR_DMISS   976  //S,            603
#define SPR_DCMP    977  //S,            603
#define SPR_HASH1   978  //S,            603
#define SPR_HASH2   979  //S,            603
#define SPR_IMISS   980  //S,            603
#define SPR_ICMP    981  //S,            603
#define SPR_RPA     982  //S,            603

#define SPR_HID0   1008  //S, 6000, 601, 603
#define SPR_HID1   1009  //S, 6000, 601
#define SPR_IABR   1010  //S, 6000, 601, 603
#define SPR_DABR   1013  //S, 6000, 601
#define SPR_PIR    1023  //S, 6000, 601

//end
